package applications.CAcollages;

import parsers.ASCII_CharStream;
import parsers.CAAlgebraParser;
import parsers.ParseException;
import terms.symbol;
import terms.term;
import util.ExitException;
import applications.collages.collageAlgebra;
import algebras.intAlgebra;

public class CAAlgebra extends collageAlgebra {
  
  private static intAlgebra ia = new intAlgebra();
  

  public synchronized Object valueOf(term t) throws ExitException {
    Object o = operationOf(t.topSymbol());
    if (o != null && o instanceof CA) return CAValue((CA)o,t);
    return super.valueOf(t);
  }
  
  private synchronized Object CAValue(CA ca, term t) throws ExitException {
    int rank = t.topSymbol().rank()-1;
    Object[] args = new Object[rank];
    for (int i = 0; i < rank; i++) {
      if ((args[i] = valueOf(t.subterm(i+1))) == null) return null;
    }
    Object S;
    if ((S = ia.valueOf(t.subterm(0)))==null) return null;
    int steps = ((Long)S).intValue();
    ca.reset();
    while (steps-- > 0) {
      ca.step();
    }
    return ca.apply(args);
  }

  protected Object apply(symbol s, Object[] args) {
    Object o = operationOf(s);
    if (o == null || o instanceof CA) return null;
    else return super.apply(s, args);
  }

  /** Initialize a <code>CAAlgebra</code> by reading its definition from a stream.
    * @see CAAlgebraParser
    * @exception ParseException if an error occurs
    */
    public void parse(ASCII_CharStream stream) throws ParseException {
      CAAlgebraParser parser = new CAAlgebraParser(stream);
      parser.CAAlgebra(this);
    }

}
